indexing
  description: "Example use of the Visitor design pattern"

class MAIN

create make

feature -- Creation

make is
  -- Creation and initialization
  local
	e : PART
  do
  -- Create the piece of equipment
    e := new_equipment

  -- Compute and print the net and discount price of the equipment
	create visitor1.execute(e)
	create visitor2.execute(e)
	print("------%NThe price is ")  print(visitor1.total)
	print(" and the discount price is ")  print(visitor2.total)
	print("%N%N")

      -- Display the various component names in e with an INVENTORY_VISITOR
	create visitor3.execute(e)
	print("Equipment consists of:%N  ")
	print(visitor3.description)
  end

-----------------------------
feature {NONE} -- Support

new_equipment : PART is
  -- Create a complex piece of equipment
  local
  do
    create the_cabinet.make("PC Cabinet", 100)
    create the_chassis.make("PC Chassis", 80)
      the_cabinet.add(the_chassis)
    create the_bus.make("MCA Bus", 50)
    create the_card.make("16Mbs Token Ring", 70)
      the_bus.add(the_card)  ;  the_chassis.add(the_bus)
    create the_disk.make("3.5 Floppy", 20)
      the_chassis.add(the_disk)
	Result := the_cabinet
  end

-----------------------------
feature {NONE} -- Equipment
  the_cabinet : CABINET -- Will contain a CHASSIS
  the_chassis : CHASSIS -- Will contain a BUS and a DISK
  the_bus : BUS  -- Will contain a CARD
  the_card : CARD -- Card to put into the chassis
  the_disk : DISk -- Disc to put into the bus

-----------------------------
feature {NONE} -- Applications
  visitor1 : PRICING_VISITOR_NET
  visitor2 : PRICING_VISITOR_DISCOUNT
  visitor3 : INVENTORY_VISITOR

end
